︠febd3099-5896-4b02-a4bf-c891176c94dai︠
%md
<h2><center>ITERATED ENCRYPTION</center></h2>
︡3dcfae88-1dd5-47ed-b6a2-cc55fa57b924︡{"done":true,"md":"<h2><center>ITERATED ENCRYPTION</center></h2>"}
︠d84a7284-f8ca-4d7c-a546-101b3c965f30s︠
def ASCIIPad(Message):
    K = (map(ord,reversed(Message)));    
    le= len(K);
    x = [100+K[i] for i in range(le)];
    x = ZZ(x,1000);
    return(x);
#################################################################################################
# The input is a number and the output is the original message. If the input is not padded ASCII#
# version of a message it returns the value: "This is not a padded ASCII string"                #
#################################################################################################
def ASCIIDepad(Number):
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        N = "";
        for i in range(Number.ndigits()/3):
            N = chr(L[i]) + N;
        return(N)
def isASCIIPadded(Number):
    N = ""
    n = Number.ndigits() % 3;
    if (n > 0):
        return False;
    L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
    for i in range(Number.ndigits()/3):
        if L[i] < 0:
            return False
        if L[i] > 255:
            return False
    return True
︡d49fc5c5-ee53-4424-b76f-80d3a7334721︡{"done":true}︡
︠a361ea89-14e5-4865-aedb-13b141017a44i︠
%md
<b>Example.</b> Let (R,e) be an RSA public key and E be the ciphertext encrypted using the given RSA key. Decrypt the message!

︡087cd17e-c03b-4edd-ad4d-cb8542b465f5︡{"done":true,"md":"<b>Example.</b> Let (R,e) be an RSA public key and E be the ciphertext encrypted using the given RSA key. Decrypt the message!"}
︠16e7417f-78f7-4cc4-855c-5cdebc3e957ds︠
R=315562173921131111550753275258954314886929684614433857059068225329589007516900986203500713113234143069878550293
e=1835588100642725811278316299646156385857628660058608776628872255463681001129596115865795858135978837517124882698892069345209251312769967638417909171551219459094621692202465346003400944724101186482909006146466321559204641
E=150598315159426420417362370315760759643687452249127260593893330249875774660837569082216166241764228321707042114

found = False

while(not found):
    E = power_mod(E,e,R)
    if(isASCIIPadded(E)):
        found = True
print "The message is:", ASCIIDepad(E)
︡9f15ff7f-a06a-4a3c-9671-4491079e3191︡{"stdout":"The message is: Elliptic Curve Cryptography\n"}︡{"done":true}︡
︠8f14777c-9e34-4399-ab20-201537b88b4ci︠
%md
The function <b>IteratedEncryption</b> takes a ciphertext along with an RSA key and encrypts until an ASCII padded message is found.
︡3de43757-09d1-436c-b092-8a47f98ef050︡{"done":true,"md":"The function <b>IteratedEncryption</b> takes a ciphertext along with an RSA key and encrypts until an ASCII padded message is found."}
︠d19f1b58-4749-447c-9003-501d588adbe5s︠
def IteratedEncryption(Ciphertext,EncExp,Modulus):
    found = False
    E = Ciphertext
    while(not found):
        power_mod(E,EncExp,Modulus)
        if(isASCIIPadded(E)):
            found = True
    print "Padded Message is:", E
    print "Message is:", ASCIIDepad(E)
    return E;

IteratedEncryption(E,e,R)
︡3bbfd299-374b-4178-9197-6a0644bccd88︡{"stdout":"Padded Message is: 169208208205212216205199132167217214218201132167214221212216211203214197212204221\nMessage is: Elliptic Curve Cryptography\n169208208205212216205199132167217214218201132167214221212216211203214197212204221\n"}︡{"done":true}︡









